// -*- C++ -*-
/*!
 * @file  ArrayOutput.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "ArrayOutput.h"
#include <stdio.h>
#include "MyUtility.h"

//+++++++++++++++++++++++++++++++++++++++++++
//O[oϐ
//+++++++++++++++++++++++++++++++++++++++++++
char inputFilePathFromCommandLine[80];
bool usingExternalFile;


//+++++++++++++++++++++++++++++++++++++++++++




// Module specification
// <rtc-template block="module_spec">
static const char* arrayoutput_spec[] =
  {
    "implementation_id", "ArrayOutput",
    "type_name",         "ArrayOutput",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    "exec_cxt.periodic.rate", "1.0",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
ArrayOutput::ArrayOutput(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_outputOut("output", m_output),

    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  registerOutPort("output", m_outputOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

/*!
 * @brief destructor
 */
ArrayOutput::~ArrayOutput()
{
}



RTC::ReturnCode_t ArrayOutput::onInitialize()
{
	//m_output.data.length(6);
	printf("onInitialize\n");
	return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t ArrayOutput::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArrayOutput::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArrayOutput::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

FILE *motionProfile;
RTC::ReturnCode_t ArrayOutput::onActivated(RTC::UniqueId ec_id)
{
	if(usingExternalFile){
		motionProfile = fopen(inputFilePathFromCommandLine,"r");
		if(motionProfile == NULL){
			printf("Ot@Cǂݍ߂܂\n");
			return RTC::RTC_ERROR;
		}
		printf("Ot@Cǂݍ݃[h\n");
	}else{
		printf("R\[[h\n");
	}
  return RTC::RTC_OK;
}

RTC::ReturnCode_t ArrayOutput::onDeactivated(RTC::UniqueId ec_id)
{
	printf("Bye\n");
	fclose(motionProfile);
  return RTC::RTC_OK;
}





RTC::ReturnCode_t ArrayOutput::onExecute(RTC::UniqueId ec_id)
{
	double temp[30];
	char line[80];
	int params;
	char work[80];
	char *splited[20];

	if(usingExternalFile){
		//t@Cǂݍňso͂
		if(  fgets(line,sizeof(line),motionProfile)  ){
			int ele = MyUtility::Split(line,',',splited,work);
			for(int i = 0 ; i < ele ; i++){
				sscanf(splited[i],"%lf",&temp[i]);
				printf("%d	%lf\n",i,temp[i]);
			}

			m_output.data.length(ele);
			for(int i=0;i < ele ; i++){
				m_output.data[i] = temp[i];
			}
			m_outputOut.write();	

			/*
			params = sscanf(line,"%lf,%lf,%lf,%lf,%lf,%lf",
			&temp[0],&temp[1],&temp[2],&temp[3],&temp[4],&temp[5]);
		
			if(params == 6){
				printf("Tx %lf,%lf,%lf,%lf,%lf,%lf\n",temp[0],temp[1],temp[2],temp[3],temp[4],temp[5]);
				m_output.data[0] = temp[0];
				m_output.data[1] = temp[1];
				m_output.data[2] = temp[2];
				m_output.data[3] = temp[3];
				m_output.data[4] = temp[4];
				m_output.data[5] = temp[5];
				m_outputOut.write();	
			}else{
				printf("tH[}bgG[\n");
			}*/
		}else{
			fclose(motionProfile);
			motionProfile = fopen("Trace.csv","r");
		}
	}else{
		std::cout << "Please input parameters\n";
		//R\[f[^ǂݍ
		fgets(line,sizeof(line),stdin);

		int ele = MyUtility::Split(line,',',splited,work);
		for(int i = 0 ; i < ele ; i++){
			sscanf(splited[i],"%lf",&temp[i]);
		}

		//std::cout << "Get=" << line << std::endl;

		std::cout << "Get=	";
		for(int i=0;i<ele;i++){
			std::cout << temp[i] << ",";
		}

		std::cout << std::endl;

		m_output.data.length(ele);
		for(int i=0;i < ele ; i++){
				m_output.data[i] = temp[i];
		}
		m_outputOut.write();	


	}
	return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t ArrayOutput::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArrayOutput::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArrayOutput::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArrayOutput::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArrayOutput::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void ArrayOutputInit(RTC::Manager* manager)
  {
    RTC::Properties profile(arrayoutput_spec);
    manager->registerFactory(profile,
                             RTC::Create<ArrayOutput>,
                             RTC::Delete<ArrayOutput>);
  }
  
};


