#include "Parser.h"
#include <list>
#include <ctime>
#include<typeinfo>
#include <algorithm>

#define _CRT_SECURE_NO_DEPRECATE


Parser::Parser(void){
	this->root = NULL;

}

Parser::~Parser(void){
}

bool Parser::GetArgument(char *source,char *dest){
	char* pos;
	pos = strchr(source,'=');
	if(pos  == NULL){
		return false;
	}
	dest = pos+1;
	return true;
}



bool Parser::OnBEGIN_PARTS(char *source){
	char *dest;
		
	this->paserLog << "Line:" << this->lineCounter << "\t" <<"OnBEGIN_PARTS	";

	if(*source){
		dest = strchr(source,'=');
		if(dest){
			dest++;

			dest = MyUtility::CueString(dest);

			if(*dest){
				std::string str;
				str = dest;
				parts = new Parts(str);
				this->sequenceMode.push(SEQUENCE_MODE_PARTS);
			}else{
				return false;
			}
			this->paserLog << "Parts[hɓ܂	"<< dest << std::endl;
		}else{
			return false;
		}
	}else{
		return false;
	}
	return true;	
}

bool Parser::OnEND_PARTS(char *source){
	this->paserLog << "Line:" << this->lineCounter << "\t"<< "OnEND_PARTS	";

	if(this->sequenceMode.top() != SEQUENCE_MODE_PARTS){
		this->paserLog << "V[PXG["	<< std::endl;
		return false;
	}

	this->paserLog << this->parts->GetName() << "ǉ" << std::endl;

	this->paserLog << "		PARTS[h甲܂" << std::endl;
	this->sequenceMode.pop();
	
	this->partsMap.insert(std::pair<std::string,Parts*>(this->parts->GetName(),this->parts));

	return true;	
}



bool Parser::DumpParts(void){
	printf("Mapɓo^ꂽ %d\n" ,this->partsMap.size());
	std::map<std::string, Parts*>::iterator i;
/*
	i = this->partsMap.begin();
	while(i != this->partsMap.end()){
		printf("NAME = %s",(*i).first);
		i++;
	}
*/
	return true;
}

bool Parser::OnTRANS(char *source){
	char *dest;
	char *arg;
	double dx,dy,dz;
	char name[80];
	char work[80];
	char *ele[80];
	int numberOfElements;
	double angle;

	RotateTransform::AXIS axis;

	this->paserLog << "Line:" << this->lineCounter << "	OnTrans	";

	//
	dest = strchr(source,'=');
	if(dest){
		dest++;

		//R}h
		dest = MyUtility::CueString(dest);

		if(*dest){
			if(strncmp(dest,"TRANSLATION",strlen("TRANSLATION")) == 0){

				//sړ̏
				arg = dest + strlen("TRANSLATION(");

				numberOfElements = MyUtility::Split(arg,',',ele,work);
				if(numberOfElements == 3){
					//ʖꍇ
					sprintf(name,"TRANS_Line%d",this->lineCounter);
					sscanf(ele[0],"%lf",&dx);
					sscanf(ele[1],"%lf",&dy);
					sscanf(ele[2],"%lf",&dz);
	
				}else if(numberOfElements == 4){
					//ʖLꍇ
					sscanf(ele[0],"%s",name);
					sscanf(ele[1],"%lf",&dx);
					sscanf(ele[2],"%lf",&dy);
					sscanf(ele[3],"%lf",&dz);
				}else{
					//R}ḧ̃tH[}bgႤꍇ
					std::cerr << "tH[}bgG[" << std::endl;
					return false;
				}

				//ǂݍ񂾃f[^ɃIuWFNg𐶐
				TranslateTransform *tempTrans = new TranslateTransform(dx,dy,dz,name);
				
				this->paserLog << "		sړIuWFNg𐶐	";
				this->paserLog << name << "," << dx << "," << dy << "," << dz << std::endl;


				//IuWFNgǉ
				switch(this->sequenceMode.top()){
				case SEQUENCE_MODE_PARTS:
					this->parts->inputTrans->AddAtTail(tempTrans);
					break;
				case SEQUENCE_MODE_CHILD:
					this->outputPath->outputTrans->AddAtTail(tempTrans);
					break;
				case SEQUENCE_MODE_DRAWN_STL:
					this->parts->drawnObject->transform->AddAtTail(tempTrans);
					break;
				default:
					this->paserLog << "`V[PX" << std::endl;
					return false;
				}

			}else if(strncmp(dest,"ROTATION",strlen("ROTATION")) == 0){
				//]ړ̏			
				arg = dest + strlen("ROTATION(");

				numberOfElements = MyUtility::Split(arg,',',ele,work);
		
				//ʖǂݍ
				int axisI;
				if(numberOfElements == 2){
					//ʖ̏ꍇ
					sprintf(name,"ROT_Line%d",this->lineCounter);
					axisI = 0;
				}else if(numberOfElements == 3){
					//ʖL̏ꍇ
					sscanf(ele[0],"%s",name);
					axisI = 1;
				}else{
					std::cerr << "tH[}bgG[" << std::endl;
					return false;
				}
				bool isNeg = false;
				int index = 0;
				//]ǂݍ
				if(ele[axisI][0] == '-'){
					isNeg = true;
					index = 1;
				}
				
				if(ele[axisI][index] == 'X'){
					axis = RotateTransform::X;
				}else if(ele[axisI][index] == 'Y'){
					axis = RotateTransform::Y;
				}else if(ele[axisI][index] == 'Z'){
					axis = RotateTransform::Z;
				}else{
					std::cerr << "tH[}bgG[" << std::endl;
					return false;		
				}
				
				
				//]pxǂݍ
				sscanf(ele[axisI+1],"%lf",&angle);

				//ǂݍ񂾃f[^ɃIuWFNg𐶐
				RotateTransform *rotTemp = new RotateTransform(axis,angle,name);
	
				this->paserLog << "		]ړIuWFNg𐶐	";
				this->paserLog << name << ","<<rotTemp->GetAxisNameFromEnum(axis)<<"," << angle << std::endl;


				//IuWFNgi[
				switch(this->sequenceMode.top()){
				case SEQUENCE_MODE_PARTS:
					this->parts->inputTrans->AddAtTail(rotTemp);
					break;
				
				case SEQUENCE_MODE_CHILD:
					this->outputPath->outputTrans->AddAtTail(rotTemp);
					break;
				
				case SEQUENCE_MODE_DRAWN_STL:
					this->parts->drawnObject->transform->AddAtTail(rotTemp);
					break;
				
				default:
					this->paserLog << "`V[PX" << std::endl;
					return false;
				}

			}else{
				std::cout << "`R[h" << std::endl;
				return false;
			}
		}
	}else{
		std::cout << "`R[h" << std::endl;
		return false;
	}
	//this->paserLog << "OnTrans甲܂" << std::endl;
	return true;	
}


bool Parser::OnBEGIN_CHILD(char *source){
	char *dest;

	this->paserLog << "Line:" << this->lineCounter << "	OnBEGIN_CHILD	";


	//V[PX̃`FbN
	if(this->sequenceMode.top() != SEQUENCE_MODE_PARTS){
		std::cout << "OnBEGIN_CHILDɂăV[PXG[" << std::endl;
		return false;
	}

	//pX擾
	if(*source)	{
		dest = strchr(source,'=');
		if(dest){
			dest++;

			dest = MyUtility::CueString(dest);

			if(*dest){
				std::string str;
				str = dest;
				this->outputPath =  this->parts->CreateOutputPath(dest);
				this->sequenceMode.push(SEQUENCE_MODE_CHILD);
				this->paserLog << "pX	" << dest << std::endl;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}else{
		return false;
	}

	return true;	
}
bool Parser::OnEND_CHILD(char *source){
	//std::cout << "OnEND_CHILD\n";
	
	this->paserLog << "Line:" << this->lineCounter << "	OnEND_CHILD	";

	if(this->sequenceMode.top() != SEQUENCE_MODE_CHILD){
		this->paserLog << "V[PXG[";
		return false;
	}

	this->sequenceMode.pop();

	this->paserLog << "pXǉ甲܂" << std::endl;
	return true;	
}




bool Parser::OnBEGIN_ASSEM(char *source){
	//printf("OnBEGIN_ASSEM\n");
	//printf("[%s]\n",source);
	return true;	
}
bool Parser::OnEND_ASSEM(char *source){
	//printf("OnEND_ASSEM\n");
	//printf("[%s]\n",source);
	return true;	
}
bool Parser::OnCOLOR(char *source){
	//std::cout << "OnCOLOR\n";
	char *dest;
	
	this->paserLog << "Line:" << this->lineCounter << "	OnColor	";

	//V[PX̃`FbN
	if(this->sequenceMode.top() != SEQUENCE_MODE_DRAWN_STL){
		this->paserLog << "V[PXG[" << std::endl;
		return false;
	}

	//F擾
	if(*source)	{
		dest = strchr(source,'=');
		if(dest){
			dest++;
	
			dest = MyUtility::CueString(dest);

			if(*dest){
				char work[80];
				char *sp[80];
				int ele;
			
				ele = MyUtility::Split(dest,',',sp,work);		
				if(ele != 3){
					this->paserLog << "tH[}bgG[" << std::endl;
					return false;			
				}

				double r,g,b;

				sscanf(sp[0],"%lf",&r);
				sscanf(sp[1],"%lf",&g);
				sscanf(sp[2],"%lf",&b);
				
				DrawnObjectBySTL *stl = dynamic_cast<DrawnObjectBySTL*>(this->parts->drawnObject);
				if(stl == NULL){
					this->paserLog << "_ELXgɎs\n";
					return false;
				}

				stl->SetColor(r,g,b);

				this->paserLog << "COLOR = " << r <<  ' ' << g << ' ' << b << std::endl;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}else{
		return false;
	}
	return true;	
}


bool Parser::OnBEGIN_DRAWN_STL(char *source){
	char *dest;
	//std::cout << "OnBEGIN_DRAWN_STL" << std::endl;
	
	this->paserLog << "Line:" << this->lineCounter << "\t"<< "OnBEGIN_DRAWN_STL	";


	if(this->sequenceMode.top() != SEQUENCE_MODE_PARTS){
		this->paserLog << "V[PXG[" << std::endl;
		return false;
	}

	this->sequenceMode.push(SEQUENCE_MODE_DRAWN_STL);
	//std::cout << "STL[h֓܂" << std::endl;

	this->paserLog << "STL[h֓܂	";

	//f擾
	if(*source)	{
		dest = strchr(source,'=');
		if(dest){
			dest++;
			dest = MyUtility::CueString(dest);

			if(*dest){
				std::string str;
				str = dest;
				//parts = new Parts(str);
				
				this->paserLog << "f= " << dest << std::endl;
				this->parts->drawnObject = new DrawnObjectBySTL(str);
			}else{
				return false;
			}
		}else{
			return false;
		}
	}else{
		return false;
	}
	return true;	
}


bool Parser::OnEND_DRAWN_STL(char *source){
	this->paserLog << "Line:" << this->lineCounter << "\t"<< "OnEND_DRAWN_STL	";

	if(this->sequenceMode.top() != 	SEQUENCE_MODE_DRAWN_STL ){
		this->paserLog << "V[PXG[" << std::endl;
		return false;
	}

	this->paserLog << "STL[h甲܂" << std::endl;
	this->sequenceMode.pop();

	return true;	
}


bool Parser::OnPATH(char *source){
	this->paserLog << "Line:" << this->lineCounter << "\t"<< "OnPATH	";
	char *dest;

	if(this->sequenceMode.top() != SEQUENCE_MODE_DRAWN_STL){
		this->paserLog  << "V[PXG[" << std::endl;
		return false;
	}

	//
	//pX擾
	if(*source)	{
		dest = strchr(source,'=');
		if(dest){
			dest++;
			dest = MyUtility::CueString(dest);
			if(*dest){
				std::string str;
				str = dest;
				this->paserLog << "pX=" <<dest << std::endl;
				DrawnObjectBySTL *temp =  dynamic_cast<DrawnObjectBySTL*>(this->parts->drawnObject);

				if(temp == NULL){
					this->paserLog << "_ELXgɎs" << std::endl;
					return false;
				}else{
					if(temp->Load(dest) == false){
						this->paserLog << "STLt@C̃I[vɎs" << std::endl;
						return false;
					}
				}
			}else{
				return false;
			}
		}else{
			return false;
		}
	}else{
		return false;
	}
	return true;	
}


bool Parser::OnBEGIN_DATAPORT(char *source){
	this->paserLog << "Line:" << this->lineCounter << "\t"<< "OnBEGIN_DATAPORT	";
	
	if(this->sequenceMode.size() == 0){
		this->sequenceMode.push(SEQUENCE_MODE_DATAPORT);
		this->paserLog << "f[^|[gN[hɓ܂" << std::endl;	
		return true;
	}
	return false;
}


bool Parser::OnEND_DATAPORT(char *source){
	this->paserLog << "Line:" << this->lineCounter << "\t"<< "OnEnd_DATAPORT	";

	if(this->sequenceMode.top() != SEQUENCE_MODE_DATAPORT){
		this->paserLog << "V[PXG[" << std::endl;
		return false;
	}

	this->sequenceMode.pop();
	this->paserLog << "f[^|[gN[h甲܂" << std::endl;
	return true;
}


bool Parser::OnCOMMENT(char *source){
	//printf("OnEND_DRAWN\n");
	//printf("[%s]\n",source);
	return true;	
}

bool Parser::OnNEXT(char *source){
	char *dest;
	
	this->paserLog << "Line:" << this->lineCounter << "\t"<< "NEXT " << source << "	";
	
	if(this->sequenceMode.top() != SEQUENCE_MODE_CHILD){
		this->paserLog << "V[PXG[" << std::endl;
		return false;
	}
	
	//
	dest = strchr(source,'=');
	if(dest){
		dest++;

		dest = MyUtility::CueString(dest);

		this->paserLog << "=" << dest << std::endl;
		this->outputPath->childName = dest;
	}else{
		return false;
	}
	return true;
}

bool Parser::LinkParts(void){
	//std::cout << "BEGIN Compile\n";
	this->paserLog << "NJn" << std::endl;



	//OROOTParts擾
	partsMapIterator it;

	if(partsMap.empty()){
		this->paserLog << "p[c܂" << std::endl;
		return NULL;
	}


	it =  partsMap.find("ROOT");	//ROOTT

	if(it == partsMap.end()){
		this->paserLog << "ROOT܂" << std::endl;
		return NULL;
	}



	//ROOTN
	this->root = it->second;



	partsMapIterator target;

	target = this->partsMap.begin();;


	//o^ꂽSĂpartsoutputɑ΂Ďm[hւ̃Ns
	while(target != partsMap.end()){
		Parts::OutputPathIterator opit = target->second->outputs.begin();

		this->paserLog << "^[Qbg=" << target->first << std::endl;
		this->paserLog << "q̐	" << target->second->outputs.size() << std::endl; 
		while(opit != target->second->outputs.end()){
			if(opit->second->childName.size()){
				this->paserLog << "	q̖O	" << opit->second->childName; 
				partsMapIterator inner =  partsMap.find(opit->second->childName);
				if(inner != partsMap.end()){
					opit->second->next = inner->second;
					this->paserLog << "	HIT!" << std::endl;
				}else{
					this->paserLog << "	MISS!!" << std::endl;
					return false;
				}
			}
			opit++;
		}
		this->paserLog << "N" << std::endl << std::endl;
		target++;
	}

	return true;




}




bool Parser::AddRotateTransform(Transform::TransformList::iterator ttit){
	//N
	RotateTransform *rt = dynamic_cast<RotateTransform*>(*ttit);
	if(rt == NULL){
		this->paserLog << "_ELXgɎs" << std::endl;
		return false;
	}else{
		this->accessedElements.push_back(rt->theta);
	}
	return true;
}


bool Parser::AddTranslateTransform(Transform::TransformList::iterator ttit,char axisIndex[]){
	TranslateTransform *tt = dynamic_cast<TranslateTransform*>(*ttit);

	if(tt == NULL){
		this->paserLog<<"_ELXgɎs" << std::endl;
		return false;
	}

	if(axisIndex[0] == 'X'){
		//std::cout << "Xǉ" << std::endl;
		this->accessedElements.push_back(tt->delta[0]);
	}else if(axisIndex[0] == 'Y'){
		//std::cout << "Yǉ"<< std::endl;
		this->accessedElements.push_back(tt->delta[1]);
	}else if(axisIndex[0] == 'Z'){
	//std::cout << "Zǉ"<< std::endl;
		this->accessedElements.push_back(tt->delta[2]);
	}else{
		return false;
	}
	return true;
}





/**
* f[^|[gƊeϐƂ̃Ns
* 
* N̓hbgŋ؂ꂽŌ߂
* ؂ꂽ1̏ꍇ̓G[ł
* ؂̐2̏ꍇ͓͕̉]s
* 3̏ꍇ͓͕̕sړỏ͕]s
* 4̏ꍇ͏o͕̕sړłD
*
* @retval true N
* @retval false Ns
*/
bool Parser::LinkDataPort(void){
	unsigned int i;
	this->paserLog << "f[^|[gƂ̃NJn" << std::endl;

	char workArea[300];
	char *splited[100];

	//Jn
	for(i = 0; i < this->dataPortKey.size(); i++){
		char *keyString;

		//hbg؂̕؂
		keyString = (char*)this->dataPortKey[i].c_str();
		keyString = MyUtility::CueString(keyString);
		this->paserLog << "target =" << keyString << std::endl; 

		int splitedEle = MyUtility::Split(keyString,'.',splited,workArea);

		if(splitedEle < 2){
			this->paserLog << "؂̐܂" << std::endl;
			return false;
		}

		//܂̓p[cT
		partsMapIterator pmit = this->partsMap.find(splited[0]);

		this->paserLog << "p[c"<<splited[0]<<"T܂\n";

		if(pmit != this->partsMap.end()){
			this->paserLog << "܂"<< std::endl;


			if(splitedEle == 2){
				//͕̉]
				Transform::TransformList::iterator ttit;

				ttit = pmit->second->inputTrans->Find(splited[1]);

				if(ttit == pmit->second->inputTrans->transformList.end()){
					this->paserLog << "ʖ[" << splited[1] << "]܂" << std::endl;
					return false;
				}
				if(this->AddRotateTransform(ttit) == false){
					return false;
				}
			}else if(splitedEle == 3){
				//͕̕sړOutputPath̉]T
				
				//͕sړǂ
				if((splited[2][0] == 'X') || (splited[2][0] == 'Y') || (splited[2][0] == 'Z')){
					//sړ̏ꍇ̏
					Transform::TransformList::iterator ttit;
					
					ttit = pmit->second->inputTrans->Find(splited[1]);
					if(ttit == pmit->second->inputTrans->transformList.end()){
						this->paserLog << "ʖ[" << splited[1] << "]܂" << std::endl;
						return false;
					}

					if(AddTranslateTransform(ttit,splited[2]) == false){
						return false;
					}
				}else{
					//OutputPath̉]T

					//OutputpathT
					Parts::OutputPathIterator opit = pmit->second->outputs.find(splited[1]);
					if(opit == pmit->second->outputs.end()){
						this->paserLog << splited[1] << "܂\n";
						return false;
					}

					//
					Transform::TransformList::iterator ttit =  opit->second->outputTrans->Find(splited[2]);
					if(ttit == opit->second->outputTrans->transformList.end()){
						this->paserLog << splited[2]<<"܂\n";
						return false;
					}

					if(this->AddRotateTransform(ttit) == false){
						return false;
					}
				}

			}else if(splitedEle == 4){
				//OutputPath̕sړT
				//std::cout << "OutputPath̕sړł\n";
				//OutputpathT
				Parts::OutputPathIterator opit = pmit->second->outputs.find(splited[1]);
				if(opit == pmit->second->outputs.end()){
					this->paserLog << splited[1] << "܂\n";
					return false;
				}

				//
				this->paserLog << "sړs " << splited[2] << "T܂\n";
				Transform::TransformList::iterator ttit =  opit->second->outputTrans->Find(splited[2]);
				if(ttit == opit->second->outputTrans->transformList.end()){
					this->paserLog << splited[2] <<"܂\n";
					return false;
				}

				if(AddTranslateTransform(ttit,splited[3]) == false){
					return false;
				}
			}
		}else{
			this->paserLog << "p[c[" << splited[0] << "]܂";
			return false;
		}
	}
	return true;
}



bool Parser::OnBEGIN_SWITCH(char *source){
	std::cout << "Line:"<< this->lineCounter << "	OnBEGIN_SWITCH" << std::endl;
	this->sequenceMode.push(SEQUENCE_MODE_SWITCH);

	return true;
}
bool Parser::OnEND_SWITCH(char *source){
	std::cout << "Line:"<< this->lineCounter << "	OnEND_SWTICH" << std::endl;
	if(this->sequenceMode.top() != SEQUENCE_MODE_SWITCH){
		this->paserLog << "OnEND_SWITCHɂăV[PXG[" << std::endl;
		return false;
	}

	this->sequenceMode.pop();
	return true;
}


bool Parser::LinkSwitch(void){
	char workArea[300];
	char *splited[100];

	//XCb`N
	std::cout << "Dump Switch key" << std::endl;

	this->paserLog << "XCb`̃NJn" << std::endl;

	for(unsigned int i=0; i< this->switchKey.size() ; i++){
		std::cout << this->switchKey[i] << std::endl;
	}

	//܂vf̃`FbN
	//Œł2vfKv
	if(this->switchKey.size() < 2){
		this->paserLog << "vf܂" << std::endl;
		return false;
	}

	//ŏ̗vf͎q̃p[c̖OĂ
	//p[c݂Ă邩`FbN
	partsMapIterator pmit = this->partsMap.find(this->switchKey[0]);
	if(pmit == this->partsMap.end()){
		this->paserLog << "qm[hƂȂp[c[" << this->switchKey[0] << "]܂" << std::endl;
		return false;
	}

	this->switchTarget = pmit->second;

	std::cout << "^[Qbg" << this->switchTarget->GetName() << std::endl;


	for(unsigned int i = 1;i<this->switchKey.size();i++){
		std::cout << i << "Ԗ" << std::endl;
		std::cout << "pX	" << this->switchKey[i] << std::endl;

		//'.'ŕăp[cT
		int splitEle = MyUtility::Split(this->switchKey[i].c_str(),'.',splited,workArea);
	
		if(splitEle != 2){
			this->paserLog << "vfG[" << std::endl;
			return false;
		}
		std::cout << "p[c	" << splited[0] << "T܂" << std::endl;
		pmit = this->partsMap.find(splited[0]);

		if(pmit == this->partsMap.end()){
			std::cout << "p[c܂" << std::endl;
			return false;
		}

		Parts::OutputPathIterator opit = pmit->second->outputs.find(splited[1]);
		if(opit == pmit->second->outputs.end()){
			std::cout << "Path܂" << std::endl;
			return false;
		}

		std::cout << "܂" << std::endl;

		//pXN
		this->switchedPath.push_back(opit->second);

	}

	//ftHgł͍ŏ̗vfɃNĂ
	this->switchedPath[0]->next = this->switchTarget;
	
	for(unsigned int i= 1 ; i < this->switchedPath.size() ; i++){
		this->switchedPath[i]->next = NULL;
	}
	return true;
}


/**
* ݒt@Cǂݍ݁Cp[c̃c[𐶐
* 
* @param path [ht@C̃pX
* @retval p[c̃c[ROOTm[hIuWFNgw|C^
*/
Parts* Parser::Execute(const char *path){
	//֐|C^
	bool (Parser::*branch[END_SWITCH+1])(char*) = {
			&Parser::OnBEGIN_PARTS,
			&Parser::OnEND_PARTS,
			&Parser::OnBEGIN_ASSEM,
			&Parser::OnEND_ASSEM,
			&Parser::OnCOLOR,
			&Parser::OnBEGIN_CHILD,
			&Parser::OnEND_CHILD,	
			&Parser::OnBEGIN_DRAWN_STL,
			&Parser::OnEND_DRAWN_STL,
			&Parser::OnTRANS,
			&Parser::OnPATH,
			&Parser::OnNEXT,
			&Parser::OnBEGIN_DATAPORT,
			&Parser::OnEND_DATAPORT,
			&Parser::OnCOMMENT,
			&Parser::OnBEGIN_SWITCH,
			&Parser::OnEND_SWITCH
		};

	char COMMAND_LIST[][MAX_COMMAND_LENGTH] ={
		"BEGIN PARTS",
		"END PARTS",
		"BEGIN ASSEM",
		"END ASSEM",
		"COLOR",
		"BEGIN CHILD",
		"END CHILD",
		"BEGIN DRAWN STL",
		"END DRAWN STL",
		"TRANS",
		"PATH",
		"NEXT",
		"BEGIN DATAPORT",
		"END DATAPORT",
		"#",
		"BEGIN SWITCH",
		"END SWITCH"
	};




	std::ifstream source(path,std::ios::in);
	char line[MAX_COMMAND_LENGTH];
	int i;
	char *head;
	int lines = 1;
	int commandKey;
	std::stack<SEQUENCE_MODE> sequenceMode;
	paserLog.open("PASER_LOG.txt",std::ios::trunc);
	paserLog << "p[T̓샍O" << std::endl;
	paserLog << "ǂݍ݌\t" << path << std::endl;

	time_t date;

	time(&date);
	this->lineCounter = 0;
	paserLog << "s\t" << asctime(gmtime(&date)) << std::endl;

	while(source.getline(line,sizeof(line))){	//s擾
		lineCounter++;
		head = line;
		if(*head){
			head = MyUtility::CueString(head);

			//R}hR[hǂݍ
			if(*head == '#'){	//Rgs̔f
				paserLog << "Line:" << lineCounter <<  "	Rg:" << head << std::endl;
			}else{
				//t@Cɏꂽ񂪒`ꂽR}hƈv邩`FbN
				//vcommandKeyɃR}h̎ʔԍ
				commandKey = -1;

				for(i = 0 ; i < sizeof(COMMAND_LIST)/MAX_COMMAND_LENGTH ; i++){
					if(strncmp(head,COMMAND_LIST[i],strlen(COMMAND_LIST[i])) == 0){
						commandKey = i;			
						break;
					}
				}

				if( commandKey == -1 ){		//vR}hȂ
					if(this->sequenceMode.top() == SEQUENCE_MODE_DATAPORT){
						this->dataPortKey.push_back(head);
					}else if(this->sequenceMode.top() == SEQUENCE_MODE_SWITCH){
						this->switchKey.push_back(head);
						std::cout << "add switch ele	" << head << std::endl;
					}else{
						paserLog <<"Line:" << lineCounter <<  "	`R[h:" << head << std::endl;
						return NULL;	//`R[h炻ŏI
					}
				}else{
					//֐|C^ŊeR}h֕
					if((this->*branch[commandKey])(&head[strlen(COMMAND_LIST[commandKey])]) == false){
						std::cout << "Line:" <<this->lineCounter << "ɂč\G[" << std::endl;
						paserLog << "Line:" <<this->lineCounter << "ɂč\G[" << std::endl;
						return NULL;
					}
				}
			}
		}
	}



	this->paserLog << "Finish Parse" << std::endl;
	
	if(this->LinkParts() == false){
		std::cout << "p[c̃NɎs" << std::endl;
		return NULL;
	}

	if(this->LinkDataPort() == false){
		std::cout << "f[^|[g̃NɎs" << std::endl;
		return NULL;
	}
/*
	if(this->LinkSwitch() == false){
		std::cout << "t[eBOm[hXCb`̃NɎs" << std::endl;
		return NULL;
	}
*/
	std::cout << "ݒt@C̃p[Xɐ...\n";
	return root;
}
