// -*- C++ -*-
/*!
 * @file  RobotMotionMonitor.cpp
 * @brief ${rtcParam.description}
 * @date $Date$
 *
 * $Id$
 */

#include "RobotMotionMonitor.h"

#include <stdio.h>
#include "Parts.h"
#include <iostream>
#include "MyUtility.h"
#include "Transform.h"
#include <sstream>
#include "RotateTransform.h"
#include "TranslateTransform.h"
#include "GLBody.h"
#include <gl/glut.h>
#include "Parser.h"
#include <process.h>
#include <windows.h>
#include <math.h>

#include "RTMonitor.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//O[oϐ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RTMonitor *rtMonitor;
/*
char configrationFilePathFromCommandLine[80];
Parts *rootOfPartsTree;
Parser *parser;
*/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++




// Module specification
// <rtc-template block="module_spec">
static const char* robotmotionmonitor_spec[] =
  {
    "implementation_id", "RobotMotionMonitor",
    "type_name",         "RobotMotionMonitor",
    "description",       "${rtcParam.description}",
    "version",           "1.0.0",
    "vendor",            "MS-lab@Tsukuba.Univ",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    "exec_cxt.periodic.rate", "1.0",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
RobotMotionMonitor::RobotMotionMonitor(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_doubleValueIn("doubleValue", m_doubleValue),
    m_boolValueIn("boolValue", m_boolValue),

    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("doubleValue", m_doubleValueIn);
  //registerInPort("boolValue", m_boolValueIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

/*!
 * @brief destructor
 */
RobotMotionMonitor::~RobotMotionMonitor()
{
}



RTC::ReturnCode_t RobotMotionMonitor::onInitialize()
{
	rtMonitor->onInitialize();
	return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t RobotMotionMonitor::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RobotMotionMonitor::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RobotMotionMonitor::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t RobotMotionMonitor::onActivated(RTC::UniqueId ec_id)
{

	return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t RobotMotionMonitor::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


/**
* f[^|[gĎAVȃf[^Ăf[^|[g̃f[^eNϐɓ]
*/
RTC::ReturnCode_t RobotMotionMonitor::onExecute(RTC::UniqueId ec_id)
{

	double buf[80];
	double stored;
	int i;

	if(m_doubleValueIn.isNew()){	//Vȃf[^L肩H
		m_doubleValueIn.read();		//ǂݍ
		//std::cout << "Get=";
		for(i= 0 ; i < rtMonitor->parser->accessedElements.size() ; i++){
			buf[i] =  m_doubleValue.data[i];
			//std::cout << buf[i] << ',';
		}
		//std::cout << std::endl;
		rtMonitor->onExecute(buf,i);
	}
	
	return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t RobotMotionMonitor::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RobotMotionMonitor::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RobotMotionMonitor::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RobotMotionMonitor::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t RobotMotionMonitor::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void RobotMotionMonitorInit(RTC::Manager* manager)
  {
    RTC::Properties profile(robotmotionmonitor_spec);
    manager->registerFactory(profile,
                             RTC::Create<RobotMotionMonitor>,
                             RTC::Delete<RobotMotionMonitor>);
  }
  
};


