#include "TranslateTransform.h"


TranslateTransform::TranslateTransform(std::string name):TransformElement(name){
	this->delta[0] = new RangedDouble();
	this->delta[1] = new RangedDouble();
	this->delta[2] = new RangedDouble();
}

TranslateTransform::TranslateTransform(double x,double y,double z,std::string name):TransformElement(name){
//	this->delta[0] = x;
//	this->delta[1] = y;
//	this->delta[2] = z;

	this->delta[0] = new RangedDouble();
	this->delta[1] = new RangedDouble();
	this->delta[2] = new RangedDouble();

	this->delta[0]->SetValue(x);
	this->delta[1]->SetValue(y);
	this->delta[2]->SetValue(z);

}


void TranslateTransform::Dump(int depth ,std::stringstream &ret){
	std::string padding = MyUtility::PaddingChar(depth,' ');

	ret << padding << "TranslateTransform" << std::endl;
	padding += "  ";
	ret << padding << "Name = " << this->name << std::endl;

	if(this->isEnable){
		ret <<padding <<  "Transform is Enable" << std::endl;
	}else{
		ret <<padding <<  "Transform is Disable" << std::endl;
	}
	
	ret << padding << "(x,y,z)=" << this->delta[0] << ","<< this->delta[1] << ","<< this->delta[2] << std::endl;
}

void TranslateTransform::Dump(std::stringstream &ret){
	this->Dump(0,ret);
}


void TranslateTransform::Dump(void){
	std::stringstream ss;
	this->Dump(ss);
	std::cout<<ss.str();
}

void TranslateTransform::Apply(void){
	glTranslated(this->delta[0]->GetValue(),this->delta[1]->GetValue(),this->delta[2]->GetValue());
}


void TranslateTransform::Draw(void){
	if(this->isDisplay){
		glDisable(GL_LIGHTING);

		//Ŏn_ƏI_
		glColor3d(1.0f,1.0f,1.0f);
		glBegin(GL_LINES);
		glVertex3d(0,0,0);
		glVertex3d(this->delta[0]->GetValue(),this->delta[1]->GetValue(),this->delta[2]->GetValue());
		glEnd();
		
		//nŎn_ƏI_
		glColor3d(1.0f,0.0f,0.0f);
		glBegin(GL_LINES);
		glVertex3d(0,0,0);
		glVertex3d(this->delta[0]->GetValue(),0,0);
		glEnd();

		glColor3d(0.0f,1.0f,0.0f);
		glBegin(GL_LINES);
		glVertex3d(this->delta[0]->GetValue(),0,0);
		glVertex3d(this->delta[0]->GetValue(),this->delta[1]->GetValue(),0);
		glEnd();

		glColor3d(0.0f,0.0f,1.0f);
		glBegin(GL_LINES);
		glVertex3d(this->delta[0]->GetValue(),this->delta[1]->GetValue(),0);
		glVertex3d(this->delta[0]->GetValue(),this->delta[1]->GetValue(),this->delta[2]->GetValue());
		glEnd();

		glEnable(GL_LIGHTING);
	}
}
	

void TranslateTransform::SetValue(double x,double y,double z){
	this->delta[0]->SetValue(x);	   
	this->delta[1]->SetValue(y);	   
	this->delta[2]->SetValue(z);	   
}

void TranslateTransform::GetValue(double retValue[3]){
	retValue[0] =  this->delta[0]->GetValue();
	retValue[1] =  this->delta[1]->GetValue();
	retValue[2] =  this->delta[2]->GetValue();
}



TranslateTransform::~TranslateTransform(){
}


